%Author: Shebuti Rayana
function [lofk] = LOF(data,train_ind,k)
    [m,~] = size(data);
    train = data(train_ind,:);
    test = data;
    [m1,~] = size(train);
    test_ind = [1:m]';
    
    distmat = Distance(test,train);
    size(distmat)
    % sort the distances
    [sD,I] = sort(distmat,2);
    k_distance = zeros(m,1);
    ind1 = ismember(test_ind,train_ind);
    ind2 = ~ismember(test_ind,train_ind);
    k_distance(ind1==1,:) = sD(ind1==1,k+1);
    k_distance(ind2==1,:) = sD(ind2==1,k);
    
    
    % construct the neighborhood matrix
    k_distance_neighborhood = zeros(m,m1);
    for p = 1:m    
        k_distance_neighborhood(p,:) = logical(distmat(p,:) <= k_distance(p));
    end

    k_distance_neighborhood_size = sum(k_distance_neighborhood,2);
    
    % compute reachability distances
    % please note that this distance is not symmetric
    reachability_distance = zeros(m,m1);
    for p = 1:m
        for o = 1:m1
            reachability_distance(p,o) = max(k_distance(train_ind(o)), distmat(p,o));
        end
    end

    % compute local reachability density
    local_reachability_density = zeros(m,1);
    for p = 1:m      
        local_reachability_density(p) = 1 ./ (1e-10+(sum(reachability_distance(p,logical(k_distance_neighborhood(p,:))) / k_distance_neighborhood_size(p))));
    end

    % compute the local outlier factor
    lofk = zeros(m,1);
    for p = 1:m
       lofk(p) = sum(local_reachability_density(logical(k_distance_neighborhood(p,:))) / local_reachability_density(p)) / k_distance_neighborhood_size(p);
    end
end

